Charm for IBM Platform Symphony Master v7.1.1


Overview
--------

IBM Platform Symphony Master

IBM Platform Symphony (Symphony) is enterprise-class software that distributes and virtualizes compute-intensive application services
and processes across existing heterogeneous IT resources.

A Symphony Master host is a server host that acts as the overall coordinator for that cluster.
If the master host goes down, another Symphony server(called as Master-Candidates) in the cluster becomes the master host.

More information available at the [IBM Knowledge Center] [platform-symphony-info]


Usage
-----

This charm will not download the Symphony Binaries as its being handled by IBM Platform Symphony Storage Charm.
The Symphony installation files will be shared when a relation is added between Symphony Storage and Symphony Master(using NFS).


Deploy
------

This charm will deploy `Symphony Master and Master Candidates`. `Symphony Master` will act as an overall master of Symphony Cluster.

To configure a Symphony Cluster, you need to deploy Symphony Storage Server, Master, Master-Candidate and node.
This charm will deploy only Symphony Master and Master Candidates( 1 Master and n number of Master Candidates), you need to deploy IBM Platform Symphony 
Storage Server in order for this charm to work. Symphony Storage Server charm will share the Symphony Installation files(/opt/ibm/platformsymphony).

To deploy IBM Platform Symphony Master Charm, follow the below steps:

      1) juju deploy ibm-platform-symphony-master
      2) juju deploy ibm-platform-symphony-storage
      3) juju add-relation ibm-platform-symphony-storage ibm-platform-symphony-master

This will create Platform Symphony Master host which is ready to add more hosts to the Symphony Cluster. To add more units, you can use `add-unit` to add more hosts to your Symphony Cluster( each added unit will be designatd as Symphony Master-Candidate host).

         juju add-unit ibm-platform-symphony-master

This command will add a Symphony Master Candidate for your existing Symphony Cluster.


### Verification of Symphony Cluster

Once the IBM Platform Symphony Master is deployed successfully and relation is established between Symphony Storage and Symphony Master, you can verify your Symphony cluster by running some symphony commands as mentioned below :
-  Login into the machine where Symphony Master is installed or Symphony Master Candidate is installed as Symphony administrator user `egoadmin`
-  Export the Symphony profile path : `. /opt/ibm/platformsymphony/profile.platform`
-  Start master by running the command: `egosh ego start`
-  Login to the master as a admin: `egosh user logon -u Admin -x Admin`
-  See the cluster and its status by issuing the command: `egosh user logon -u Admin -x Admin`


### To remove the units of Symphony Master

         juju remove-unit <unit name of the Symphony Master you want to remove>

This will remove the unit from the existing Symphony Cluster.(ego conf files will be updated and Symphony files will be unmounted)
 
 ** Note : If you remove the unit which is the Symphony Master host, still your Symphony Cluster will be working as the next Symphony Master Candidate will become the new Master until a new Master is added.** 



### Removing Relations
An IBM Platform Symphony Master charm can be related to Symphony Storage Charm as well as Symphony node Charm. Incase you want to remove the relation between these, refer to the below steps:
   
      juju remove-relation ibm-platform-symphony-master ibm-platform-symphony-node
This will remove the node host information from the symphony configuration files and the
node host will no longer be part of the existing Symphony Cluster.

      juju remove-relation ibm-platform-symphony-storage ibm-platform-symphony-master
This will stop the Symphony Daemons on the Master and remove the entries from Symphony Configuration Files. Then it will unmount the Symphony shared installation files.

      

IBM Platform Symphony Information
---------------------------------
(1) General Information
Information on IBM Platform Symphony available at the [IBM Knowledge Center] [platform-symphony-info]

(2) Contact Information
For issues with this charm, please contact IBM Juju Support Team <jujusupp@us.ibm.com>

(3) Known Limitations
This charm makes use of Juju Status commands, and requires juju 1.24 or greater


<!-- Links -->

[license-info]: http://www-03.ibm.com/software/sla/sladb.nsf/search

[platform-symphony-info]: https://www.ibm.com/support/knowledgecenter/SSGSMK_7.1.1/sym_kc_welcome.html
