from charmhelpers.core import hookenv
from charms.reactive import hook
from charms.reactive import RelationBase
from charms.reactive import scopes
from charmhelpers.core import (
    hookenv,
)



class nfsstorageProvides(RelationBase):
    # Every unit connecting will get the same information
    scope = scopes.UNIT

    # Use some template magic to declare our relation(s)
    @hook('{provides:nfsstorage}-relation-joined')
    def joined(self):
        print("I am in relation joined state for provides")
        conversation = self.conversation()
        conversation.remove_state('{relation_name}.departing')
        conversation.set_state('{relation_name}.joined')
     

    @hook('{provides:nfsstorage}-relation-changed')
    def changed(self):
        print("I am in relation changed avaialble state for provides")
        conversation = self.conversation()
        #conversation.remove_state('{relation_name}.departing')
        conversation.set_state('{relation_name}.available')
        

    @hook('{provides:nfsstorage}-relation-departed')
    def departed(self):
        # Remove the state that our relationship is now available to our principal layer(s)
        print("I am in departed hook")
        conversation = self.conversation()
        conversation.remove_state('{relation_name}.joined')
        conversation.remove_state('{relation_name}.available')
        conversation.set_state('{relation_name}.departing')
        
        
    def dismiss_departed(self):
        for conv in self.conversations():
            conv.remove_state('{relation_name}.departing')
            print("I am in dismiss departed function")
     

    def host_name(self, hostname_storage):
        for conv in self.conversations():
            conv.set_remote(data={
            'hostname_storage': hostname_storage,
    })

   
    def settip_client(self, ip_client):
        for conv in self.conversations():
            conv.set_remote(data={
            'ip_client': ip_client,
    })

       
    def nfsclient_ip(self):
        ip = []
        for conv in self.conversations():
            ip.append(conv.get_remote('private-address'))
        return ip

   
    def nfsclient_service(self):
        serv = []
        for conv in self.conversations():
            serv.append(conv.scope)
        return serv

                   
         


