from charms.reactive import hook
from charms.reactive import RelationBase
from charms.reactive import scopes
from charmhelpers.core import (
    hookenv,
)

class nfsstorageRequires(RelationBase):
    scope = scopes.GLOBAL
    auto_accessors = ['hostname_storage', 'private-address']

    @hook('{requires:nfsstorage}-relation-joined')
    def joined(self):
        self.remove_state('{relation_name}.departing')
        self.set_state('{relation_name}.joined')
               

    @hook('{requires:nfsstorage}-relation-changed')
    def changed(self):
        self.remove_state('{relation_name}.departing')
        local_ip = hookenv.unit_private_ip()
        if (str(self.get_remote('ip_client')) == local_ip) and (str(self.get_remote('hostname_storage')) != "None"):
            self.set_state('{relation_name}.available')
               
        
    @hook('{requires:nfsstorage}-relation-departed')
    def departed(self):
        # Remove the state that our relationship is now available to our principal layer(s)
        self.remove_state('{relation_name}.available')
        self.remove_state('{relation_name}.joined')
        self.set_state('{relation_name}.departing')


    def private_address(self):
        return self.get_remote('private-address')


    def get_ipclient(self):
        return self.get_remote('ip_client')

    def get_hostname(self):
        return self.get_remote('hostname_storage')


                          