from charms.reactive import RelationBase, hook, scopes


class DistPeers(RelationBase):
    scope = scopes.UNIT

    @hook('{peers:platformmaster}-relation-joined')
    def joined(self):
        conv = self.conversation()
        conv.remove_state('{relation_name}.departed')
        conv.set_state('{relation_name}.joined')
        
    @hook('{peers:platformmaster}-relation-changed')
    def joined(self):
        conv = self.conversation()
        conv.remove_state('{relation_name}.departed')
        print(str(conv.get_remote('hostname_node')))
        if  (str(conv.get_remote('hostname_node')) != "None"):
             conv.set_state('{relation_name}.available')
        

    @hook('{peers:platformmaster}-relation-departed')
    def departed(self):
        conv = self.conversation()
        conv.remove_state('{relation_name}.joined')
        conv.remove_state('{relation_name}.available')
        conv.set_state('{relation_name}.departed')
        
    def dismiss_departed(self):
        for conv in self.conversations():
            print("I am in dismiss departed")
            conv.remove_state('{relation_name}.departed')

    def dismiss_joined(self):
        for conv in self.conversations():
            print("I am in dismiss joined")
            conv.remove_state('{relation_name}.joined')

    def get_unitip(self):
        ip = []
        for conv in self.conversations():
            ip.append(conv.get_remote('private-address'))
        return ip

      
    def set_unithost(self, hostname_node):
        for conv in self.conversations():
             conv.set_remote(data={
            'hostname_node': hostname_node,
    })

              
    def get_unithost(self):
        host = []
        for conv in self.conversations():
            host.append(conv.get_remote('hostname_node'))
        return host

           
   