from charmhelpers.core import hookenv
from charms.reactive import hook
from charms.reactive import RelationBase
from charms.reactive import scopes




class platformmasterProvides(RelationBase):
    # Every unit connecting will get the same information
    scope = scopes.UNIT

    # Use some template magic to declare our relation(s)
    @hook('{provides:platformmaster}-relation-joined')
    def joined(self):
        conversation = self.conversation()
        conversation.remove_state('{relation_name}.departed')
        conversation.set_state('{relation_name}.joined')
        
        
    @hook('{provides:platformmaster}-relation-changed')
    def changed(self):
        conversation = self.conversation()
        conversation.remove_state('{relation_name}.departed')
        if (str(conversation.get_remote('hostname_server')) != "None"):
            conversation.set_state('{relation_name}.available')

        
    @hook('{provides:platformmaster}-relation-departed')
    def departed(self):
        # Remove the state that our relationship is now available to our principal layer(s)
        conversation = self.conversation()
        conversation.remove_state('{relation_name}.available')
        conversation.remove_state('{relation_name}.joined')
        conversation.set_state('{relation_name}.departed')
                  

    def host_name(self, hostname_master):
        for conv in self.conversations():
            conv.set_remote(data={
            'hostname_master': hostname_master,
    })

    def notify_server(self, master_reconfig_flag):
        for conv in self.conversations():
            conv.set_remote(data={
            'master_reconfig_flag': master_reconfig_flag,
    })

    def private_address(self):
        ip = []
        for conv in self.conversations():
            ip.append(conv.get_remote('private-address'))
        return ip

    def server_hostname(self):
        host = []
        for conv in self.conversations():
            host.append(conv.get_remote('hostname_server'))
        return host

   

