
from charms.reactive import hook
from charms.reactive import RelationBase
from charms.reactive import scopes


class platformmasterRequires(RelationBase):
    scope = scopes.UNIT

    @hook('{requires:platformmaster}-relation-joined')
    def joined(self):
        conversation = self.conversation()
        conversation.remove_state('{relation_name}.departed')
        conversation.set_state('{relation_name}.joined')
        
        
    @hook('{requires:platformmaster}-relation-changed')
    def changed(self):
        conversation = self.conversation()
        conversation.remove_state('{relation_name}.departed')
        conversation.set_state('{relation_name}.available')
        if (((str(conversation.get_remote('master_reconfig_flag')) == "MasterReConfigReady") or (str(conversation.get_remote('master_reconfig_flag')) == "NotMaster")) and (str(conversation.get_remote('hostname_master')) != "None")):
           conversation.set_state('{relation_name}.MasterReConfigReady')
                
   
    @hook('{requires:platformmaster}-relation-departed')
    def departed(self):
         # Remove the state that our relationship is now available to our principal layer(s)
         conversation = self.conversation()
         conversation.remove_state('{relation_name}.MasterReConfigReady')
         conversation.remove_state('{relation_name}.available')
         conversation.remove_state('{relation_name}.joined')
         conversation.set_state('{relation_name}.departed')
        
        
    def dismiss_departed(self):
        for conv in self.conversations():
            conv.remove_state('{relation_name}.departed')
            print("Dismiss departed state")


    def private_address(self):
        ip = []
        for conv in self.conversations():
            ip.append(conv.get_remote('private-address'))
        return ip

    def get_hostname(self):
        host = []
        for conv in self.conversations():
            host.append(conv.get_remote('hostname_master'))
        return host

    def notify_server(self):
        flag = []
        for conv in self.conversations():
            flag.append(conv.get_remote('master_reconfig_flag'))
        return flag


    def set_hostname(self, hostname_server):
        for conv in self.conversations():
            conv.set_remote(data={
            'hostname_server': hostname_server,
    })



    